import random
import string

from flask import Blueprint, make_response, request, redirect, session

bp = Blueprint('auth', __name__, url_prefix="/auth")


ACCESS_TOKEN = ''.join(random.choice(string.ascii_lowercase) for i in range(64))


ERROR_TEXT =  """
              For security-reasons we must make sure you are the person who executed jon :D <br />
              <form action="" method="get">
                  <input type="password" name="token" placeholder="Token" />
                  <input type="submit" value="login" />
              </form>
              <hr />

              """


def before_request():
    """
    If the correct token query parameter is passed along with any request,
    we mark this session authenticated by setting `session["authenticated"]`.
    """
    if "token" in request.args:
        if request.args["token"] == ACCESS_TOKEN:
            session["authenticated"] = ()
        return redirect(request.path)

    if not "authenticated" in session:
        return ERROR_TEXT, 403


@bp.get("/logout")
def logout():
    session.pop("authenticated", None)
    return redirect("/")
